#include <os.h>
#include "fileio.h"
#include "filebrowser.h"

int open(uint8_t* scrbuf, char* path, char* savepath, char** textbufferp){
    FILE* file;
    char tmp[FILENAME_MAX];
    int filelen;
	if(show_msgbox_2b("Document not saved!", "Save Document?", "Yes", "No") == 1){//if yes chosen
		if(save(scrbuf, path, savepath, *textbufferp) == 1){//if error
			file = fopen(strcat(path,"noname.txt.tns"), "wb");
			*(strrchr(path,'/') + 1) = '\0';
			fwrite(*textbufferp, 1, strlen(*textbufferp), file);
			fclose(file);
		}
	}
	chdir(path);
	wait_no_key_pressed();
	if(filebrowser(scrbuf, tmp, "Open File") == 1)
		return 1;
	strcpy(savepath, tmp);
    /*//no filebrowser:
    char* tmp;
    int inputlen;
    int filelen;
    wait_no_key_pressed();
    inputlen = show_msg_user_input("Open File", "", path, &tmp);
    if(inputlen == -1)
        return 1;
    strcpy(savepath, tmp);
    free(tmp);
    */
    file = fopen(savepath,"rb");
    if(file == NULL)
        return 1;
    fseek(file, 0, SEEK_END);
    filelen = ftell(file);
    printf("filelen %i\n",filelen);
    rewind(file);
    free(*textbufferp);
    *textbufferp = malloc(filelen + 1024 - (filelen%1024));
    if(*textbufferp == NULL){
		printf("open: malloc failed\n");
		fclose(file);
        return 1;
    }
    fread(*textbufferp, 1, filelen, file);
    fclose(file);
    (*textbufferp)[filelen] = '\0';
    return 0;
}

int save(uint8_t* scrbuf, char* path, char* savepath, char* textbuffer){
	FILE* file;
    if(strlen(savepath) == 0)
        return saveAs(scrbuf, path, savepath, textbuffer);
    else{
        file = fopen(savepath,"wb");
        fwrite(textbuffer,1,strlen(textbuffer),file);
        fclose(file);
        return 0;
    }
}

int saveAs(uint8_t* scrbuf, char* path, char* savepath, char* textbuffer){
    FILE* file;
    char tmp[FILENAME_MAX];
    chdir(path);
    wait_no_key_pressed();
    if(filebrowser(scrbuf, tmp, "Save As...") == 1)
		return 1;
    /*no filebroser:
    char* tmp;
	int inputlen = 0;
    inputlen = show_msg_user_input("Save file as", "", path, &tmp);
    if(inputlen == -1 || inputlen > 247){
        show_msgbox("", "Document not saved!");
        return 1;
    }
	free(tmp);*/
    strcpy(savepath,tmp);
    file = fopen(savepath, "r");
    if(file != NULL){
        fclose(file);
        if(show_msgbox_2b("Save As","This file already exists! Do you really want to overwrite it?", "Yes", "No") == 2)
            return 1;
    }
    if(strstr(savepath, ".tns") != strrchr(savepath, '\0') - 4){
        if(show_msgbox_2b("No filename extensinon .tns", "Append .tns to the path? Else the file won't be visible in the My Documents screen.", "Yes", "No") == 1)
            strcat(savepath, ".tns");
    }
    file = fopen(savepath,"wb");
    fwrite(textbuffer,1,strlen(textbuffer),file);
    fclose(file);
    return 0;
}
